/* -------------------------------------------------
	USARTʐM
	RpCIvVɂfosc̐ݒsƁB

	
		#include <util/delay.h>
		sio_init(57600,8);    // SIOݒ
		sei();

	M
		sendChar();			//1M
		sendString();		//񑗐M

		getReceivedData();	//M̎擾

	URL : http://d.hatena.ne.jp/yaneurao/20080713

------------------------------------------------ */

#ifndef __USART__H__
#define __USART__H__

/* sioݒ */
void sio_init(unsigned int baud,int bit)
{
    unsigned int ubrr = (((F_CPU>>4)+(baud>>1))/baud-1);
    // UBRRݒ肷ƂɊۂߏĂB

    UBRR0H = (unsigned char)(ubrr>>8);    // {[[g8bit
    UBRR0L = (unsigned char)ubrr;        // {[[g8bit
    UCSR0B = (1<<RXEN0) | (1<<TXEN0) | (1<<RXCIE0) | (1<<TXCIE0);
    // M,M荞݋
    switch(bit)
    {
        case 8:
            UCSR0C = (3<<UCSZ00) ;        // stopbit 1bit , 8bitM
            break;
        case 5:
            UCSR0C = 0;                 // stopbit 1bit , 5bitM
    }
}

// byte`ĂB
typedef unsigned char byte;

// t[Ȃ̂256 bytes̑MbufferOŗpӂ

volatile char usart_recvData[256]={0};    // USARTŎMf[^Bring buffer
volatile byte usart_recv_write;        // ݂writeʒu(usart_recvDataindex)
         byte usart_recv_read;         // ݂readʒu(usart_recvDataindex)
volatile char usart_sendData[256]={0};    // USARTőMf[^Bring buffer
         byte usart_send_write;        // ݂writeʒu(usart_sendDataindex)
volatile byte usart_send_read;         // ݂readʒu(usart_sendDataindex)


// f[^MĂ邩̃`FbNBMĂȂ0B
int is_received()
{
    return  (usart_recv_write !=  usart_recv_read) ? 1 : 0;
    // readʒuwriteʒuقȂȂΎMf[^͂
}

// f[^M܂őҋ@
void wait_for_receiving()
{
    while(!is_received())
        ;
}

// Mf[^ԂBMf[^Ȃꍇ͎M܂őҋ@B
int getReceivedData()
{
    wait_for_receiving();
    return usart_recvData[usart_recv_read++];
}

// 荞݂ɂM
ISR(USART_RX_vect)
{
    usart_recvData[usart_recv_write++] = UDR0;    // Mf[^Mobt@Ɋi[
}

// Mobt@Ƀf[^΁A1oCgM郋[`B
// IɎgpĂ邾Ȃ̂Ń[U[͌ĂяoȂŁB
void private_send_char()
{
    if (usart_send_write != usart_send_read)
        UDR0 = usart_sendData[usart_send_read++];// Mobt@̃f[^𑗐M
}

// 荞݂ɂ鑗M
ISR(USART_TX_vect)
{
    private_send_char();
}

// 1oCgM
void sendChar(int c)
{
    // Mobt@ςȂ҂
    while(((usart_send_write + 1) & 0xff) == usart_send_read)
        ;

    // ͂ƂꑗMobt@Ƀf[^ςށB
    usart_sendData[usart_send_write++] = c;

    // MWX^ZbgĂ == Młԁ@Ȃ΁A
    // xMĂB
    if (UCSR0A & (1<<UDRE0))
        private_send_char();

    // ႦΎ̂悤ɑMobt@Ƀf[^ς܂UDR0ɒڃANZXR[h
    // 悭ȂB
    // if (UCSR0A & (1<<UDRE0))
    //    UDR0 = c;
    // else
    //    usart_sendData[usart_send_write++] = c;
    // ́Aelse傪suԂUSART_TX_vectɂ銄荞݂A
    // usart_send_write == usart_send_readłꍇAsendCharĂяo
    // ̑M܂łŐς񂾃f[^MȂłB
}

// ̑M
void sendString(char *p)
{
    while(*p)
        sendChar(*p++);
}

#endif
